Subject: [Forces-protocol] RE: PL<-->TML:: topic 1

From: "Khosravi, Hormuzd M" <[email-masked]>
Date: Mon, 19 Apr 2004 21:09:12 -0700

Hi Jamal,

-----Original Message-----
From: [email-masked]
[mailto:[email-masked]] On Behalf Of Jamal Hadi Salim

Lets take an example of CE-PL sending a message that requires a reliable
delivery; assume we have a UDP and TCP connection in the TML:

I would like to send such a message from the PL level via the TML with
some indication to the TML that this message needs to be delivered
reliably (obviously via TCP in this example). Clearly it is cleaner for
the PL to have no clue that the TPC connection is being used.
2-3 ways i could do it:
1) call a speacial function[1] which is translated by the CE-TML to mean
send via TCP
OR
2) call a generic function[1] with flags turned to say "reliability
needed" and the TML translates this to mean send via TCP.
OR
3) just send the Forces Messages with some of its flags turned on to
mean reliability on and such a message is translated to mean send via
TCP.

#3 may be the API-avoidance scheme.

[HK] Exactly, #3 is what I was explaining in my last email that I just
sent out. (Use fields/flags in the Common Header to correspond to a
transport service e.g. TCP connection in the TML). 

I think we are on the same page now, Hopefully this issue is resolved :)

Regards
Hormuzd

_______________________________________________
Forces-protocol mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/forces-protocol

---

From: Robert Haas <[email-masked]>
Date: Tue, 20 Apr 2004 16:33:35 +0200

On the reliability example: remember that ForCES-level reliability is 
somewhat orthogonal to transport-level reliability. At the ForCES level, 
I want to get an ACK back from a FE to confirm that it could update a 
firewall rule successfully, for instance.

So if I tag my ForCES message with "reliability enabled", the TML COULD 
choose to send it over TCP, but this is not mandatory, as using TCP 
alone is not going to be sufficient to ensure reliable processing at the 
FE. Actually, the TML could choose UDP, as potential retransmissions 
anyay need to be taken care of at the PL level as well.

Or do you have different views ? Please explain.

Regards,
-Robert

-- 
Robert Haas
IBM Zurich Research Laboratory
Säumerstrasse 4
CH-8803 Rüschlikon/Switzerland
phone +41-1-724-8698  fax +41-1-724-8578  http://www.zurich.ibm.com/~rha

---

From: Jamal Hadi Salim <[email-masked]>
Date: 20 Apr 2004 10:50:07 -0400

> anyay need to be taken care of at the PL level as well.

Good point to consider again in terms of TML and header definition.

cheers,
jamal

---

From: "Weiming Wang" <[email-masked]>
Date: Tue, 20 Apr 2004 20:50:23 +0800

Hi Jamal, Hormuzd,

Jamal, pls let me concentrate on your example first by replying this email
firstly.

----- Original Message -----
From: "Khosravi, Hormuzd M" <[email-masked]>
Hi Jamal,
-----Original Message-----

[Weiming] Among the three schemes, I also more appreciate 3), but I just wonder
if this is all for TML-PL, e.g., what then for congestion control, HA, etc?
Basically, I think it is only a specific scheme for reliability. I think we now
can only say that we have approved to use something like metadata/fields/flags
for reliability control. Moreover, I think the scheme is also quite at the
abstact level. We then may have to answer more questions as how we then define
the 'reliability', how we can know the TML support such 'reliability', and what
then if the TML can not supply enough capability for such 'reliability'?  From
these viepoints, I'm afraid we still need to use mechanisms like TML capability
and TML attributes so as to properly configure the TML before we can actually
use such metadata/fields in the protocol messages. I notice that Jamal seems to
say such TML configuration is better to be left for CEM and FEM. If it is, then
I think it may libarate our protocol team a lot. So, Hormuzd, what's your
opinion?

Cheers,
Weiming